hpp-corbaserver: hpp::corbaserver::Obstacle Interface Reference

hpp-corbaserver 9.0.2 Corba server for Humanoid Path Planner applications

Loading...
Searching...
No Matches
Public Member Functions | List of all members
hpp::corbaserver::Obstacle Interface Reference

Obstacle management. More...

`import </local/robotpkg/var/tmp/robotpkg/path/py-hpp-corbaserver/work/hpp-corbaserver-9.0.2/idl/hpp/corbaserver/obstacle.idl;`

## Public Member Functions
void | loadObstacleModel (in string filename, in string prefix) raises (Error)
void | loadPolyhedron (in string obstacleName, in string filename) raises (Error)
| Load a polyhedron as an obstacle from a file.
void | loadObstacleModelFromString (in string urdfString, in string prefix) raises (Error)
void | loadPointCloudFromFilename (in string objectName, in string filename) raises (Error)
void | loadPointCloudFromPoints (in string objectName, in double resolution, in floatSeqSeq points) raises (Error)
void | removeObstacle (in string objectName) raises (Error)
| Remove an obstacle.
void | removeObstacleFromJoint (in string objectName, in string jointName, in boolean collision, in boolean distance) raises (Error)
| Remove an obstacle from outer objects of a joint body.
void | cutObstacle (in string objectName, in floatSeq aabb) raises (Error)
void | addObstacle (in string objectName, in boolean collision, in boolean distance) raises (Error)
| Add an obstacle to the set of obstacles.
void | moveObstacle (in string objectName, in Transform_ cfg) raises (Error)
| Move an obstacle to a given configuration.
void | getObstaclePosition (in string objectName, out Transform_ cfg) raises (Error)
Names_t | getObstacleNames (in boolean collision, in boolean distance) raises (Error)
Polyhedra
void | createPolyhedron (in string polyName) raises (Error)
| create an empty polyhedron.
void | createBox (in string inBoxName, in double x, in double y, in double z) raises (Error)
| Create a box.
void | createSphere (in string name, in double radius) raises (Error)
void | createCylinder (in string name, in double radius, in double length) raises (Error)
unsigned long | addPoint (in string polyName, in double x, in double y, in double z) raises (Error)
| Add a point to a polyhedron.
unsigned long | addTriangle (in string polyName, in unsigned long pt1, in unsigned long pt2, in unsigned long pt3) raises (Error)
| Add a point to a polyhedron.

## Detailed Description

Obstacle management.

## Member Function Documentation

## ◆ addObstacle()

void hpp::corbaserver::Obstacle::addObstacle | ( | in string | objectName,
|  | in boolean | collision,
|  | in boolean | distance
| ) |  |
raises | ( | Error
| ) |  |

Add an obstacle to the set of obstacles.

Parameters

  objectName | name of the object.
  collision | whether collision with object should be computed
  distance | whether distance to object should be computed

Exceptions

  Error. |

Note
  The obstacle should have been built using one of methods
  - hpp::Obstacle::createPolyhedron,
  - hpp::Obstacle::createBox
  - hpp::Obstacle::addPoint
  - hpp::Obstacle::addTriangle.
  Build the bounding volume hierarchy of the object if needed.

## ◆ addPoint()

unsigned long hpp::corbaserver::Obstacle::addPoint | ( | in string | polyName,
|  | in double | x,
|  | in double | y,
|  | in double | z
| ) |  |
raises | ( | Error
| ) |  |

Add a point to a polyhedron.

Parameters

  polyName | the name of the polyhedron.
  x | coordinate of the point.
  y | coordinate of the point.
  z | coordinate of the point.

Returns
  rank of point in polyhedron.

## ◆ addTriangle()

unsigned long hpp::corbaserver::Obstacle::addTriangle | ( | in string | polyName,
|  | in unsigned long | pt1,
|  | in unsigned long | pt2,
|  | in unsigned long | pt3
| ) |  |
raises | ( | Error
| ) |  |

Add a point to a polyhedron.

Parameters

  polyName | the name of the polyhedron.
  pt1 | rank of first point in polyhedron.
  pt2 | rank of second point in polyhedron.
  pt3 | rank of third point in polyhedron.

Returns
  rank of triangle in polyhedron.

## ◆ createBox()

void hpp::corbaserver::Obstacle::createBox | ( | in string | inBoxName,
|  | in double | x,
|  | in double | y,
|  | in double | z
| ) |  |
raises | ( | Error
| ) |  |

Create a box.

Parameters

  inBoxName | name of the box
  x,y,z | Size of the box

## ◆ createCylinder()

void hpp::corbaserver::Obstacle::createCylinder | ( | in string | name,
|  | in double | radius,
|  | in double | length
| ) |  |
raises | ( | Error
| ) |  |

Create a cylinder

Parameters

  name | name of the cylinder
  radius | radius of the cylinder
  length | length of the cylinder

## ◆ createPolyhedron()

void hpp::corbaserver::Obstacle::createPolyhedron | ( | in string | polyName | ) |
raises | ( | Error
| ) |  |

create an empty polyhedron.

Parameters

  polyName | name of the polyhedron.

Exceptions

  Error. |

## ◆ createSphere()

void hpp::corbaserver::Obstacle::createSphere | ( | in string | name,
|  | in double | radius
| ) |  |
raises | ( | Error
| ) |  |

Create a sphere

Parameters

  name | name of the sphere
  radius | radius of the sphere

## ◆ cutObstacle()

void hpp::corbaserver::Obstacle::cutObstacle | ( | in string | objectName,
|  | in floatSeq | aabb
| ) |  |
raises | ( | Error
| ) |  |

Cut the obstacle with the given AABB

Parameters

  aabb | a vector of 6 floats. The 3 first represent one corner and the 3 last represent the opposite corner.

## ◆ getObstacleNames()

Names_t hpp::corbaserver::Obstacle::getObstacleNames | ( | in boolean | collision,
|  | in boolean | distance
| ) |  |
raises | ( | Error
| ) |  |

Get list of obstacles

Parameters

  collision | whether to return obstacle for collision,
  distance | whether to return obstacles for distance computation

Returns
  list of obstacles

## ◆ getObstaclePosition()

void hpp::corbaserver::Obstacle::getObstaclePosition | ( | in string | objectName,
|  | out Transform_ | cfg
| ) |  |
raises | ( | Error
| ) |  |

Get the position of an obstacle

Parameters

  objectName | name of the polyhedron.

Return values

  cfg | Position of the obstacle.

Exceptions

  Error. |

## ◆ loadObstacleModel()

void hpp::corbaserver::Obstacle::loadObstacleModel | ( | in string | filename,
|  | in string | prefix
| ) |  |
raises | ( | Error
| ) |  |

Load obstacle from urdf file

Parameters

  package | Name of the package containing the model.
  filename | name of the urdf file, it may contain "package://"
  prefix | prefix added to object names in case the same file is loaded several times

The kinematic structure of the urdf file is ignored. Only the geometric objects are loaded as obstacles.

## ◆ loadObstacleModelFromString()

void hpp::corbaserver::Obstacle::loadObstacleModelFromString | ( | in string | urdfString,
|  | in string | prefix
| ) |  |
raises | ( | Error
| ) |  |

Load obstacle from urdf file

Parameters

  package | Name of the package containing the model.
  urdfString | XML string to parse
  prefix | prefix added to object names in case the same file is loaded several times

The kinematic structure of the urdf file is ignored. Only the geometric objects are loaded as obstacles.

## ◆ loadPointCloudFromFilename()

void hpp::corbaserver::Obstacle::loadPointCloudFromFilename | ( | in string | objectName,
|  | in string | filename
| ) |  |
raises | ( | Error
| ) |  |

Load (or update if it exists) a point cloud from a filename.

Parameters

  filename | a filename whose format must be compatible with Octomap

## ◆ loadPointCloudFromPoints()

void hpp::corbaserver::Obstacle::loadPointCloudFromPoints | ( | in string | objectName,
|  | in double | resolution,
|  | in floatSeqSeq | points
| ) |  |
raises | ( | Error
| ) |  |

Load (or update if it exists) a point cloud from a set of points

Parameters

  resolution | OcTree resolution. See Octomap::OcTree for more info.
  points | a Nx3 matrix representing the point cloud.

Note
  OmniORB has a limit in the size of arguments that you can send. If you have an exception about the message size limit being exceeded, you can try to increase the limit. The option is giopMaxMsgSize. The value must be changed both on the server and client side. See https://omniorb.sourceforge.io/omni40/omniORB/omniORB004.html for the different ways of changing a configuration value. The easiest is likely to set the value in file `${OmniORB_INSTALLATION_PREFIX}/etc/omniORB.cfg`

## ◆ loadPolyhedron()

void hpp::corbaserver::Obstacle::loadPolyhedron | ( | in string | obstacleName,
|  | in string | filename
| ) |  |
raises | ( | Error
| ) |  |

Load a polyhedron as an obstacle from a file.

Parameters

  obstacleName | name of the polyhedron.
  filename | name of the file.

Exceptions

  Error. |

## ◆ moveObstacle()

void hpp::corbaserver::Obstacle::moveObstacle | ( | in string | objectName,
|  | in Transform_ | cfg
| ) |  |
raises | ( | Error
| ) |  |

Move an obstacle to a given configuration.

Parameters

  objectName | name of the polyhedron.
  cfg | the configuration of the obstacle.

Exceptions

  Error. |

Note
  The obstacle is not added to local map impl::Obstacle::collisionListMap.
  Build the collision entity of polyhedron for KCD.

## ◆ removeObstacle()

void hpp::corbaserver::Obstacle::removeObstacle | ( | in string | objectName | ) |
raises | ( | Error
| ) |  |

Remove an obstacle.

Parameters

  objectName | name of the object to remove

## ◆ removeObstacleFromJoint()

void hpp::corbaserver::Obstacle::removeObstacleFromJoint | ( | in string | objectName,
|  | in string | jointName,
|  | in boolean | collision,
|  | in boolean | distance
| ) |  |
raises | ( | Error
| ) |  |

Remove an obstacle from outer objects of a joint body.

Parameters

  objectName | name of the object to remove,
  jointName | name of the joint owning the body,
  collision | whether collision with object should be ignored,
  distance | whether distance to object should be ignored.

Exceptions

  Error. |

The documentation for this interface was generated from the following file:

- idl/hpp/corbaserver/obstacle.idl